"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ExecutableFunction subclass:#ExternalFunction 
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'System-Support'
!

ExternalFunction comment:'
COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

$Header: /cvs/stx/stx/libbasic2/Attic/ExtFunc.st,v 1.5 1995-02-15 10:29:21 claus Exp $
'!

!ExternalFunction class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libbasic2/Attic/ExtFunc.st,v 1.5 1995-02-15 10:29:21 claus Exp $
"
!

documentation
"
    Instances of this class represent external (non-Smalltalk) functions.
    Also, the class provides access to custom functions (see the demo
    functions provided in main.c).
    These custom functions enable you to call c functions even if no
    stc is available.

    This clas is still in cosntruction.
"
! !

!ExternalFunction class methodsFor:'custom functions'!

callCustomFunction:nr
    ^ self callCustomFunction:nr withArguments:#()

    "
     ExternalFunction callCustomFunction:0
     ExternalFunction callCustomFunction:999 
    "
!

callCustomFunction:nr with:arg
    ^ self callCustomFunction:nr withArguments:(Array with:arg)

    "
     ExternalFunction callCustomFunction:1 with:'hello world'
    "
!

callCustomFunction:nr with:arg1 with:arg2
    ^ self callCustomFunction:nr withArguments:(Array with:arg1 with:arg2)

    "
     ExternalFunction callCustomFunction:2 with:(Float pi) with:1.0
    "
!

callCustomFunction:nr with:arg1 with:arg2 with:arg3
    ^ self callCustomFunction:nr 
		withArguments:(Array with:arg1 with:arg2 with:arg3)
!

callCustomFunction:nr withArguments:argArray
    |retVal|

%{
    extern int stxNCustomFunctions;
    extern CUSTOMFUNCTION customFunctions[];
    int (* func)();

    if (__isSmallInteger(nr) && __isArray(argArray)) {
	int nargs = _arraySize(argArray);
	int functionNr;

	functionNr = _intVal(nr);
	if ((functionNr >= 0) && (functionNr < stxNCustomFunctions)) {
	    /*
	     * now, call the function; passing nargs and arg-vector
	     */
	    func = customFunctions[functionNr].func;
	    if (func) {
		int ok;

		retVal = self;
		ok = (*func)(nargs, &retVal, _ArrayInstPtr(argArray)->a_element);
		if (ok) {
		    RETURN (retVal);
		}
	    }
	}
    }
%}.
    "
     either an invalid customFunction-nr was given,
     or customFunction returned 0 (failure)
    "
    self primitiveFailed

    "
     ExternalFunction callCustomFunction:2 withArguments:#(1.0 1.0)
     ExternalFunction callCustomFunction:999 withArguments:#(1.0 1.0)
    "
! 

callCustomFunctionNamed:name withArguments:argArray
    |index|

    index := self indexOfCustomFunctionNamed:name.
    index notNil ifTrue:[
	^ self callCustomFunction:index withArguments:argArray
    ].
    "
     no such function exists
    "
    self primitiveFailed

    "
     ExternalFunction callCustomFunctionNamed:'demoFunction0'
				withArguments:#()
    "
!

indexOfCustomFunctionNamed:functionName

%{  /* NOCONTEXT */
    extern int stxNCustomFunctions;
    extern CUSTOMFUNCTION customFunctions[];

    if (__isString(functionName)) {
	char *nm;
	int i;

	nm = _stringVal(functionName);
	for (i=0; i<stxNCustomFunctions; i++) {
	   if (strcmp(customFunctions[i].name, nm) == 0) {
		RETURN (_MKSMALLINT(i));
	   }
	}
    }
%}.
    ^ nil

    "
     ExternalFunction indexOfCustomFunctionNamed:'demoFunction0'  
     ExternalFunction indexOfCustomFunctionNamed:'fooBar' 
    "
! !
